VERSION 5.00
Begin VB.Form frmCustomList 
   Caption         =   "Linked Listboxes"
   ClientHeight    =   2895
   ClientLeft      =   1530
   ClientTop       =   1545
   ClientWidth     =   6180
   Icon            =   "frmCustomList.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   193
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   412
   Begin VB.PictureBox picList 
      Height          =   2475
      Left            =   60
      ScaleHeight     =   161
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   380
      TabIndex        =   0
      Top             =   345
      Width           =   5760
      Begin VB.PictureBox picColSpliter 
         Appearance      =   0  'Flat
         BackColor       =   &H80000012&
         ForeColor       =   &H80000008&
         Height          =   2190
         Left            =   2340
         ScaleHeight     =   2160
         ScaleWidth      =   0
         TabIndex        =   3
         Top             =   150
         Visible         =   0   'False
         Width           =   15
      End
      Begin VB.PictureBox picHeader 
         Appearance      =   0  'Flat
         AutoRedraw      =   -1  'True
         BorderStyle     =   0  'None
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   285
         Index           =   0
         Left            =   -15
         MouseIcon       =   "frmCustomList.frx":000C
         ScaleHeight     =   19
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   104
         TabIndex        =   2
         Top             =   -15
         Width           =   1560
      End
      Begin VB.ListBox lstColumn 
         Appearance      =   0  'Flat
         Height          =   2175
         Index           =   0
         ItemData        =   "frmCustomList.frx":015E
         Left            =   -15
         List            =   "frmCustomList.frx":0160
         TabIndex        =   1
         Top             =   255
         Width           =   1575
      End
   End
End
Attribute VB_Name = "frmCustomList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how VB listboxes can be *linked*
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  '
  ' IMPORTANT NOTE: the best way to impliment the concept displayed
  ' in this demo would be to create a class to wrap all of these
  ' routines in a single object.  You could also create a usercontrol
  ' to accomplish this.  Wrapping this code within a single object is
  ' left as an excersize for the reader.
  
  
  Private Const API_FALSE As Long = 0&
  Private Const API_TRUE As Long = 1&

  Private Const SM_CXVSCROLL As Long = 2
  Private Const SM_CYEDGE As Long = 46&
  
  Private Const DB_RAISED As Long = 4&
  Private Const DB_SUNKEN As Long = 2&
  Private Const DB_RAISEDBUTTON As Long = 5&
  Private Const DB_FRAME As Long = 6&
  Private Const DB_DUBBLESUNKEN As Long = 10&

  Private Const BF_RECT = &HF

  ' zero based
  Private m_nNumColumns As Long
  
  Private m_nCurRightIndex As Long
  
  Private m_nScrollWidth As Long
  Private m_nFrameWidth As Long
    
  Private Type COLUMN_INFO
    sCaption As String
    nWidth As Long
  End Type ' COLUMN_INFO
  
  Private aColumnInfo() As COLUMN_INFO
  
  Private Const LB_SETHORIZONTALEXTENT As Long = &H194&

  Private Type POINTL
    x As Long
    y As Long
  End Type
  
  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type
  
  Private Declare Function GetCursorPosPoint& Lib "user32" Alias "GetCursorPos" (lpPoint As POINTL)
  
  Private Declare Function GetSystemMetrics& Lib "user32" (ByVal nIndex&)
  
  Private Declare Function ScreenToClient& Lib "user32" (ByVal hWnd&, lpPoint As POINTL)
  
  Private Declare Function DrawEdge& Lib "user32" (ByVal hDC&, qrc As RECT, ByVal edge&, ByVal grfFlags&)
  
  Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd&, ByVal wMsg&, ByVal wParam&, lParam As Any) As Long

Private Sub Form_Load()
  
  ' zero based
  m_nNumColumns = 2
  
  ' dimention the array of column info structs and add the info
  ReDim aColumnInfo(m_nNumColumns) As COLUMN_INFO
  
  aColumnInfo(0).nWidth = 150
  aColumnInfo(0).sCaption = "Column 1"
  
  aColumnInfo(1).nWidth = 150
  aColumnInfo(1).sCaption = "Column 2"
  
  aColumnInfo(2).nWidth = 300
  aColumnInfo(2).sCaption = "Column 3"
  
  Dim i&, j&
  
  ' get the width of scrollbars and window borders on the system
  m_nScrollWidth = GetSystemMetrics(SM_CXVSCROLL) + 1
  m_nFrameWidth = GetSystemMetrics(SM_CYEDGE)
  
  ' set the first *column* width
  lstColumn(0).Width = aColumnInfo(0).nWidth
  picHeader(0).Width = lstColumn(0).Width - (m_nScrollWidth - 1)
      
  picHeader(0).Tag = aColumnInfo(0).sCaption
  
  ' draw the *button* on the header
  DrawHeaderButton picHeader(0), DB_RAISEDBUTTON
  
  ' size and arange the other columns
  For i = 1 To m_nNumColumns
    Load lstColumn(i)
    
    With lstColumn(i)
      .Move lstColumn(i - 1).Left + (lstColumn(i - 1).Width - m_nScrollWidth), .Top, aColumnInfo(i).nWidth
      .Visible = True
      .ZOrder
    End With
    
    Load picHeader(i)
    
    With picHeader(i)
      If i = m_nNumColumns Then
        .Move lstColumn(i).Left + 1, (-1), lstColumn(i).Width - 2
      Else
        .Move lstColumn(i).Left + 1, (-1), lstColumn(i).Width - m_nScrollWidth
      End If
      .Visible = True
      .ZOrder
      .Tag = aColumnInfo(i).sCaption
    End With
    
    DrawHeaderButton picHeader(i), DB_RAISEDBUTTON

  Next
  
  ' set the width of the container picturebox
  picList.Width = (lstColumn(m_nNumColumns).Left + lstColumn(m_nNumColumns).Width) + ((m_nFrameWidth * 2) - 1)
  
  ' set up the splitter that is used to indicate column sizing
  picColSpliter.Move 0, 0, 1, picList.ScaleHeight
  
  ' set the form width
  Width = ((picList.Width + (picList.Left * 2)) * Screen.TwipsPerPixelX) + (Width - (ScaleWidth * Screen.TwipsPerPixelX))
  
  ' add some stuff to the listboxes
  For i = 0 To 100
    For j = 0 To m_nNumColumns
      lstColumn(j).AddItem "Test " & CStr(i)
    Next
  Next

  ' Add horizontal scrollbars to each listbox
  For i = 0 To m_nNumColumns
    Call SendMessage(lstColumn(i).hWnd, LB_SETHORIZONTALEXTENT, lstColumn(i).Width + 500, ByVal API_FALSE)
  Next
  
  Show
  
End Sub

Private Sub lstColumn_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)

  Dim i&
  
  ' sync up the listboxes.  if you want all of the listindexes to be the same, do it here...
  For i = 0 To m_nNumColumns
    If i <> Index Then lstColumn(i).ListIndex = True
  Next

End Sub

Private Sub lstColumn_Scroll(Index As Integer)
  
  Dim i&
  
  ' scroll the listboxes in sync
  For i = 0 To m_nNumColumns - 1
    lstColumn(i).TopIndex = lstColumn(m_nNumColumns).TopIndex
  Next
  
End Sub

Private Sub picHeader_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
  ' handle drawing the header button in the correct state and displaying the sizing splitter bar
  If (Button = 1) Then
    ' if the mouse pointer is not set for sizing do the button code...
    If (picHeader(Index).MousePointer = vbDefault) Then
      DrawHeaderButton picHeader(Index), DB_DUBBLESUNKEN
      
    Else ' we need to move the splitter bar here....
      picColSpliter.Left = lstColumn(m_nCurRightIndex).Left
      picColSpliter.Visible = True
      picColSpliter.ZOrder
    End If
  End If
  
End Sub

Private Sub picHeader_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
  ' draw the header button in the correct state and displaying the sizing splitter bar
  ' also return click events here
  If Button = 1 Then
    With picHeader(Index)
      ' if the mouse pointer is not set for sizing do the button code...
      If .MousePointer = vbDefault Then
        If (((x >= 0) And (x <= .ScaleWidth)) And ((y >= 0) And (y <= .ScaleHeight))) Then
          DrawHeaderButton picHeader(Index), DB_RAISEDBUTTON
          
    ' this is where the "click" event for the column header should go
          MsgBox "Header Click"
        
        End If
        
      Else ' we need to size the coulmns here....
        picColSpliter.Visible = False
        
        SizeColumnHeader m_nCurRightIndex, False
        DrawHeaderButton picHeader(m_nCurRightIndex), DB_RAISEDBUTTON

        SizeColumnHeader m_nCurRightIndex - 1, True
        DrawHeaderButton picHeader(m_nCurRightIndex - 1), DB_RAISEDBUTTON
        
        SizeListBox m_nCurRightIndex
        SizeListBox m_nCurRightIndex - 1

      End If
    End With
  End If

End Sub

Private Sub picHeader_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
  ' handle drawing the header button or moving the splitter here
  Static nSideOfHeader& ' <-  1 = left side, 2 = right side
  Dim nShift&, udtHeaderPos As POINTL, udtCursorPos As POINTL
  
  If (Button = 1) And (picHeader(Index).MousePointer = vbDefault) Then
    ' draw the header button in the correct state
    With picHeader(Index)
      If ((x >= 0) And (x <= .ScaleWidth)) And ((y >= 0) And (y <= .ScaleHeight)) Then
        DrawHeaderButton picHeader(Index), DB_DUBBLESUNKEN
      Else
        DrawHeaderButton picHeader(Index), DB_RAISEDBUTTON
      End If
    End With
    Exit Sub
  End If

  ' see if we need to deal with sizing...
  If (picHeader(Index).MousePointer = vbCustom) And (Button = 1) Then
    nSideOfHeader = nSideOfHeader
  ElseIf (x < 2) And (Index > 0) Then
    nSideOfHeader = 1
    m_nCurRightIndex = Index
  ElseIf (x > (picHeader(Index).Width - 3) And (Index < m_nNumColumns)) Then
    nSideOfHeader = 2
    m_nCurRightIndex = Index + 1
  Else
    nSideOfHeader = 0
  End If
  
  If nSideOfHeader Then
    picHeader(Index).MousePointer = vbCustom
    
    If Button = 1 Then
      Call GetCursorPosPoint(udtCursorPos)
      Call ScreenToClient(picList.hWnd, udtCursorPos)
                                                                                      
      If (m_nCurRightIndex > 0) And _
                              (udtCursorPos.x - lstColumn(m_nCurRightIndex - 1).Left) <= m_nScrollWidth Then
        udtCursorPos.x = lstColumn(m_nCurRightIndex - 1).Left + m_nScrollWidth
              
      ElseIf ((lstColumn(m_nCurRightIndex).Left + lstColumn(m_nCurRightIndex).Width) - _
                                                    udtCursorPos.x) <= (m_nScrollWidth * 2) Then
        udtCursorPos.x = (lstColumn(m_nCurRightIndex).Left + lstColumn(m_nCurRightIndex).Width) - _
                                                                                          (m_nScrollWidth * 2)
      End If
      
      picColSpliter.Left = udtCursorPos.x
            
    End If
  Else
    picHeader(Index).MousePointer = vbDefault
  End If
  
End Sub

Private Sub DrawHeaderButton(oButton As PictureBox, ByVal fButtonState As Long)
  ' draw the header button in the desired state
  Dim lRect As RECT

  With oButton
    ' clear the deck....
    .Cls
        
    ' determin which state to draw the button in and set the values accordingly
    Select Case fButtonState
      Case DB_RAISEDBUTTON
        lRect.Right = oButton.ScaleWidth
        lRect.Bottom = oButton.ScaleHeight
        
        .CurrentX = 5
        .CurrentY = (.ScaleHeight \ 2) - (.TextHeight(.Tag) \ 2)
        
      Case DB_DUBBLESUNKEN
        lRect.Right = oButton.ScaleWidth - 1
        lRect.Bottom = oButton.ScaleHeight - 1
        
        .CurrentX = 6
        .CurrentY = ((.ScaleHeight \ 2) - (.TextHeight(.Tag) \ 2)) + 1
        
    End Select
      
    ' print the stored button text in the location set by the current X & Y
    oButton.Print .Tag
  
    ' draw the button in the desired state
    Call DrawEdge(.hDC, lRect, fButtonState, BF_RECT)
    
  End With

End Sub

Private Sub SizeColumnHeader(ByVal Index&, ByVal bIsLeftList As Boolean)
  ' handle sizing the column headers
  Select Case Index
    Case 0
      picHeader(Index).Width = picColSpliter.Left + 1
    Case Is < m_nNumColumns
      If bIsLeftList Then
        picHeader(Index).Width = picColSpliter.Left - picHeader(Index).Left
      Else
        picHeader(Index).Move picColSpliter.Left, (-1), picHeader(Index + 1).Left - picColSpliter.Left
      End If
    Case m_nNumColumns
      picHeader(Index).Move picColSpliter.Left, (-1), picList.ScaleWidth - picColSpliter.Left
  End Select

End Sub

Private Sub SizeListBox(ByVal Index&)
  ' handle sizing the listboxes
  Select Case Index
    Case 0
      lstColumn(Index).Move picHeader(Index).Left, lstColumn(Index).Top, _
                                                        picHeader(Index).Width + (m_nScrollWidth + 1)
    Case Is < m_nNumColumns
      lstColumn(Index).Move picHeader(Index).Left - 1, lstColumn(Index).Top, _
                                                        picHeader(Index).Width + m_nScrollWidth
    Case m_nNumColumns
      lstColumn(Index).Move picHeader(Index).Left - 1, lstColumn(Index).Top, picHeader(Index).Width + 2
  End Select

End Sub
